import request from '@/utils/request';
import { BaseResponse } from './type';

/**
 * - 预案类型: zhdd_plan_type;
 * - 事件类型: zhdd_incident_type;
 * - 事件状态 + 事件页面右侧菜单: zhdd_incident_status;
 * - 事件等级: zhdd_incident_level;
 * - 事件来源: zhdd_incident_source;
 * - 上报单位 + 归属部门 + 预案页面右侧菜单 : zhdd_org_upload;
 * - 应急资源 + 资源页面右侧菜单:zhdd_resource
 * - 首页标记点: zhdd_screen_type
 * - 车辆类型: zhdd_car_type
 * - 处置方案用户角色: zhdd_incident_task_role
 */
export type DictType =
  | 'zhdd_plan_type'
  | 'zhdd_incident_type'
  | 'zhdd_incident_status'
  | 'zhdd_incident_level'
  | 'zhdd_incident_source'
  | 'zhdd_org_upload'
  | 'zhdd_resource'
  | 'zhdd_screen_type'
  | 'zhdd_car_type'
  | 'zhdd_incident_task_role';

export interface GlobalDict {
  dictLabel: string; // 字典标签
  dictValue: string; // 字典键值
}

export interface DictReponse extends BaseResponse {
  data: GlobalDict[];
}

/** 字典数据查询 */
export const getGlobalDict = (dictType: DictType) =>
  request<DictReponse>('GET', {
    url: `/system/dict/data/type/${dictType}`,
  });

export interface UploadData {
  /** 文件名 */
  fileName?: string;
  /** 文件相对路径 */
  url?: string;
}

export interface UploadReponse extends BaseResponse {
  data: UploadData;
}
export const upload = (file: File) => {
  const form = new FormData();
  // debugger
  form.append('file', file);
  return request<UploadReponse>('POST', {
    url: '/common/upload',
    headers: {
      'Content-Type': 'multipart/form-data',
    },
    data: form,
  });
};
