import { defineComponent } from 'vue';
import './index.scss';

export default defineComponent({
  name: 'Dialog',
  props: {
    title: String,
    onPedding: Function,
    onSave: Function,
    onClose: Function,
    visible: Boolean,
    width: String,
  },
  setup(props, ctx) {
    return () => (
      <el-dialog
        modelValue={props.visible}
        title={props.title}
        width={props.width ?? '30%'}
        destroyOnClose
        onClose={() => {
          ctx.emit('update:visible', false);
          props.onClose && props.onClose();
        }}
        custom-class="dialog-container">
        {ctx.slots.default && ctx.slots.default()}

        <div class="footer-container">
          {ctx.slots.buttons ? (
            ctx.slots.buttons()
          ) : (
            <>
              <el-button
                size="small"
                onClick={() => ctx.emit('update:visible', false)}>
                取消
              </el-button>
              <el-button
                size="small"
                type="primary"
                onClick={async () => {
                  const result = props.onPedding && (await props.onPedding());
                  if (result) {
                    ctx.emit('update:visible', false);
                  }
                }}>
                确认
              </el-button>
            </>
          )}
        </div>
      </el-dialog>
    );
  },
});
