import { reactive, defineComponent } from 'vue';
import { useRouter } from 'vue-router';
import './index.scss';

export default defineComponent({
  name: 'FormContainer',
  props: {
    title: String,
  },
  setup(props, ctx) {
    const state = reactive({
      loading: false,
    });

    const router = useRouter();

    return () => (
      <div v-loading={state.loading} class="new-edit-form-container">
        <div class="form-title">
          <span>{props.title}</span>
          <el-button
            type="text"
            icon="el-icon-back"
            onClick={() => router.back()}>
            返回
          </el-button>
        </div>
        <div class="form-body">
          <el-row justify="center">
            <el-col span={18}>
              {ctx.slots.default && ctx.slots.default()}
            </el-col>
          </el-row>
        </div>
      </div>
    );
  },
});
